require "defines"

local floor,random = math.floor,math.random
local sqrtwo = math.sqrt(2)
local magnetmax = 16

glob.tick = game.tick%3+1
glob.radii = glob.radii or {}

--[[
game.oninit(function() glob.tick = glob.tick or game.tick%3+1 end)
game.onload(function() glob.tick = glob.tick or game.tick%3+1 end)
--]]

local newpos = {}
local splat={name="item-on-ground",position=newpos,stack = {name="advanced-circuit",count = 1}}

remote.addinterface("magnet",{
	litter=function()
		local base
		for _,p in pairs(game.players) do
			base = {x=floor(p.position.x-30),y=floor(p.position.y-30)}
			for x=base.x,base.x+60,.5 do
				for y=base.y,base.y+60,.5 do
					newpos.x = x
					newpos.y = y
					if game.canplaceentity(splat) then game.createentity(splat) end
				end
			end
		end
	end
})

game.onevent(defines.events.ontick, function(event)
	if glob.tick > 0 then glob.tick = glob.tick-1 return end
	glob.tick=3
	
	local index, hand
	for _,player in pairs(game.players) do
		index=player.position
		if #game.findentitiesfiltered{area={index,index},name="player"} > 0 then
		--if (player.character and player.character.valid) then 
			--local player = game.player
			hand = player.cursorstack
			index = player.name
			
			if hand and hand.name=="magnet" then
				local posx,posy = player.position.x,player.position.y
				if glob.radii[index] then
					glob.radii[index] = glob.radii[index] + .3
					if glob.radii[index] > magnetmax then glob.radii[index] = magnetmax end
				else
					glob.radii[index] = 2
				end
				local magradius=glob.radii[index]
				local mgsquare=magradius * magradius
				local mgroot= magradius / sqrtwo
				local dx,dy
				local itemlist = game.findentitiesfiltered{area={{x=posx-magradius,y=posy-magradius},{x=posx+magradius,y=posy+magradius}}, name="item-on-ground"}
				local thestack
				local badlist={}
				for k,v in pairs(itemlist) do
					thestack = v.stack
					if thestack then
						dx=v.position.x-posx
						if dx<0 then dx=-dx end
						dy=v.position.y-posy
						if dy<0 then dy=-dy end
						if (dx<mgroot and dy<mgroot) or (dx*dx+dy*dy < mgsquare) then
							if not badlist[thestack.name] and player.caninsert(thestack) then
								local r=player.getitemcount(thestack.name)
								player.insert(thestack)
								if player.getitemcount(thestack.name)~=r then
									itemlist[k].destroy()
								else
									badlist[thestack.name]=true
								end
							else
								--player.print("Cannot pick up "..thestack.name..".")
							end
						end
					end
				end
			else
				if glob.radii[index] then glob.radii[index]=nil end
			end
		end --inactive player
	end
end)
